% Nested Support Vector Machines
% NCS-SVM demo
% 
% Gyemin Lee, University of Michigan
% 2009.5.17
% 
clear
home

datastr = 'banana';
dataidx = '1';

% 
% NCS-SVM test
% 
% training data set
[xt yt] = util_rdbenchdata(datastr, dataidx, 'train');

% kernel bandwidth
ncs_sigma = 0.5;

% regularization parameter
ncs_lambdamax = cssvm_lambdamax(xt, yt, @knl_radial, ncs_sigma);
ncs_lambda = ncs_lambdamax*0.7;

% breakpoints 
ncs_gammanum = 5;
ncs_gamma = linspace(0,1,ncs_gammanum)';

% train NCS-SVM
[ncs_alpha, ncs_ff, ncs_dual] = ncssvm_wb(xt, yt, @knl_radial, ncs_sigma, ncs_lambda, ncs_gamma);

% plot decision boudaries
figure(2)
plot_cssvm_set(xt,yt,@knl_radial,ncs_sigma,ncs_lambda,ncs_alpha);
